<template>
    <ion-page>
        <ion-header :translucent="true">
            <ion-toolbar>
                <ion-buttons slot="start">
                    <ion-menu-button color="primary"></ion-menu-button>

                    <ion-button
                        color="tertiary"
                        @click="$router.push({ name: Route.deviceList })"
                    >
                        <ion-icon
                            slot="icon-only"
                            :ios="returnUpBack"
                            :md="returnUpBack"
                        ></ion-icon>
                    </ion-button>
                </ion-buttons>

                <ion-title>Zařízení</ion-title>
            </ion-toolbar>
        </ion-header>

        <ion-content :fullscreen="true">
            <ion-progress-bar
                v-if="loading"
                type="indeterminate"
            ></ion-progress-bar>
            <h2 class="center" v-if="isNew">Nové zařízení</h2>

            <ion-text
                color="tertiary"
                v-for="error of v$.$errors"
                :key="error.$uid"
                class="color: danger;"
                ><p>
                    <span>Chyba: </span>
                    <strong>{{ error.$property }} {{ error.$message }}</strong>
                </p>
            </ion-text>

            <form>
                <ion-list>
                    <ion-item>
                        <ion-input
                            v-model="curValue.name"
                            aria-label="Jméno zařízení"
                            label="Jméno zařízení (name)"
                            placeholder="Zadejte jméno (name)"
                            required
                        ></ion-input>
                    </ion-item>

                    <ion-item>
                        <ion-input
                            v-model="curValue.mac"
                            aria-label="MAC adresa"
                            label="MAC adresa"
                            placeholder="Zadejte MAC adresu"
                            required
                        ></ion-input>
                    </ion-item>

                    <ion-item>
                        <ion-input
                            v-model="curValue.ip"
                            aria-label="IP adresa"
                            label="IP adresa"
                            placeholder="Zadejte IP adresu"
                            required
                        ></ion-input>
                    </ion-item>

                    <ion-item>
                        <ion-toggle v-model="curValue.isKnown"
                            >Zařízení známé</ion-toggle
                        >
                    </ion-item>

                    <ion-item>
                        Expirace zařízení:
                        <ion-datetime-button
                            datetime="isKnownExpiration"
                        ></ion-datetime-button>

                        <ion-modal :keep-contents-mounted="true">
                            <ion-datetime
                                max="2099-12-31T23:59:59"
                                id="isKnownExpiration"
                                v-model="curValue.isKnownExpiration"
                                ><span slot="title"
                                    >Expirace zařízení</span
                                ></ion-datetime
                            >
                        </ion-modal>
                    </ion-item>

                    <ion-item v-if="userStore.data.isAdmin">
                        <user-select v-model="curValue.ownerId"></user-select>
                    </ion-item>

                    <ion-item>
                        <group-select
                            v-model="curValue.deviceGroupIdList"
                        ></group-select>
                    </ion-item>

                    <ion-item>
                        <ion-toggle v-model="curValue.hasInternetAccess"
                            >Přístup do internetu</ion-toggle
                        >
                    </ion-item>

                    <ion-item>
                        Expirace přístupu do internetu:
                        <ion-datetime-button
                            datetime="internetAccessExpiration"
                        ></ion-datetime-button>

                        <ion-modal :keep-contents-mounted="true">
                            <ion-datetime
                                max="2099-12-31T23:59:59"
                                v-model="curValue.internetAccessExpiration"
                                id="internetAccessExpiration"
                                ><span slot="title"
                                    >Expirace přístupu do internetu</span
                                ></ion-datetime
                            >
                        </ion-modal>
                    </ion-item>

                    <ion-item>
                        <device-port-select
                            v-model="curValue.devicePortList"
                        ></device-port-select>
                    </ion-item>

                    <ion-item v-if="!isNew">
                        <ion-grid>
                            <ion-row>
                                <ion-col>Fotky:</ion-col>
                                <ion-col>
                                    <input
                                        multiple
                                        @change="uploadPhotos"
                                        type="file"
                                        accept="image/png, image/gif, image/jpeg"
                                    />
                                </ion-col>
                            </ion-row>

                            <ion-row>
                                <ion-col
                                    size="6"
                                    size-sm="6"
                                    size-md="4"
                                    size-lg="2"
                                    v-for="photo in devicePhotoList"
                                    :key="photo.id"
                                >
                                    <ion-img
                                        :alt="photo.filename"
                                        :src="
                                            config.uri.devicePhoto +
                                            photo.filename
                                        "
                                    ></ion-img>

                                    <ion-button
                                        color="danger"
                                        shape="round"
                                        @click="removePhotoWrap(photo.id)"
                                        ><ion-icon
                                            slot="icon-only"
                                            :icon="close"
                                        ></ion-icon
                                    ></ion-button>
                                </ion-col>
                            </ion-row>
                        </ion-grid>
                    </ion-item>

                    <ion-item>
                        <static-ip-select
                            v-model="curValue.staticIpId"
                        ></static-ip-select>
                    </ion-item>

                    <ion-item>
                        <ion-input
                            v-model="curValue.wifiName"
                            aria-label="Jméno WiFi"
                            label="Jméno WiFi"
                            placeholder="Zadejte jméno WiFi"
                        ></ion-input>
                    </ion-item>

                    <ion-item>
                        <ion-input
                            v-model="curValue.wifiPass"
                            aria-label="Heslo WiFi"
                            label="Heslo WiFi"
                            placeholder="Zadejte heslo WiFi"
                        ></ion-input>
                    </ion-item>

                    <ion-item>
                        <ion-toggle v-model="curValue.isAllowed"
                            >Povolené zařízení</ion-toggle
                        >
                    </ion-item>
                </ion-list>

                <ion-button @click="send">Odeslat</ion-button>
            </form>
        </ion-content>
    </ion-page>
</template>

<script setup lang="ts">
import GroupSelect from '@/component/Forms/GroupSelect.vue'
import DevicePortSelect from '@/component/Forms/DevicePortSelect.vue'
import UserSelect from '@/component/Forms/UserSelect.vue'
import StaticIpSelect from '@/component/Forms/StaticIpSelect.vue'
import {
    CreateDevice,
    CreateDevicePort,
    CreateDevicePortFromDevice,
    DeviceGroup,
    DevicePhoto,
} from '@/gql/graphql'
import toast from '@/helpers/toast'
import router from '@/router'
import { Route } from '@/router/route'
import { useUserStore } from '@/stores/userStore'
import {
    IonImg,
    IonIcon,
    IonButton,
    IonButtons,
    IonProgressBar,
    IonContent,
    IonHeader,
    IonMenuButton,
    IonPage,
    IonTitle,
    IonToolbar,
    IonInput,
    IonDatetimeButton,
    IonModal,
    IonItem,
    IonList,
    IonToggle,
    IonDatetime,
    IonText,
    IonCol,
    IonGrid,
    IonRow,
} from '@ionic/vue'
import { MutateResult, useLazyQuery, useMutation } from '@vue/apollo-composable'
import gql from 'graphql-tag'
import { returnUpBack } from 'ionicons/icons'
import { reactive, ref, toRaw } from 'vue'
import { useRoute } from 'vue-router'
import { useVuelidate } from '@vuelidate/core'
import {
    required$,
    maxLength$,
    minLength$,
    macAddress$,
    ipAddress$,
} from '@/helpers/validator'
import config from '@/config/config'
import { close } from 'ionicons/icons'

const route = useRoute()
const userStore = useUserStore()

const now = new Date()
now.setSeconds(0)
now.setMinutes(0)
now.setHours(0)

const devicePhotoList = ref<DevicePhoto[]>([])

const curValue = reactive<any>({
    name: '',
    mac: '',
    ip: '',
    isKnown: false,
    isKnownExpiration: now.toISOString(),
    ownerId: '',
    deviceGroupIdList: [],
    hasInternetAccess: false,
    internetAccessExpiration: now.toISOString(),
    devicePortList: [],
    staticIpId: '',
    wifiName: '',
    wifiPass: '',
    isAllowed: false,
})

const rules = {
    name: {
        req: required$,
        min: minLength$(3),
        max: maxLength$(20),
    },
    mac: { req: required$, mac: macAddress$ },
    ip: { req: required$, ip: ipAddress$ },
    isKnown: { req: required$ },
    isKnownExpiration: { req: required$ },
    ownerId: {},
    deviceGroupIdList: {},
    hasInternetAccess: { req: required$ },
    internetAccessExpiration: { req: required$ },
    devicePortList: {},
    staticIpId: {},
    wifiName: {},
    wifiPass: {},
    isAllowed: { req: required$ },
}

const v$ = useVuelidate(rules, curValue)

const uploadPhotos = (object: any) => {
    if (object.target.validity) {
        createDevicePhoto({
            devicePhoto: {
                deviceId: route.params.id,
                file: object.target.files[0],
                displayOrder: 0,
            },
            context: {
                hasUpload: true,
            },
        }).then((result) => {
            devicePhotoList.value.push(result?.data?.createDevicePhoto)
        })
    }
}

// Původní hodnota pro update
let originalValue: CreateDevice | null = null

const isNew = ref(true)

const {
    loading,
    load,
    variables,
    refetch: refetchDevice,
} = useLazyQuery(gql`
    query device($id: ID!) {
        device(id: $id) {
            name
            mac
            ip
            isKnown
            isKnownExpiration
            hasInternetAccess
            internetAccessExpiration
            wifiName
            wifiPass
            isAllowed
            owner {
                id
            }
            deviceGroupList {
                id
            }
            devicePortList {
                id
                hubPort
                devicePort
                expiration
            }
            devicePhotoList {
                id
                filename
            }
            staticIp {
                id
            }
        }
    }
`)

// Načíst data do formuláře
if (route.params.id !== undefined && route.params.id !== '') {
    isNew.value = false
    variables.value = { id: route.params.id }
    const data = load()

    if (data) {
        data.then((result) => {
            [
                'name',
                'mac',
                'ip',
                'isKnown',
                'hasInternetAccess',
                'wifiName',
                'wifiPass',
                'isAllowed',
            ].forEach((param) => {
                curValue[param] = result.device[param]
            })
            ;['isKnownExpiration', 'internetAccessExpiration'].forEach(
                (param) => {
                    curValue[param] = result.device[param] ?? now
                }
            )

            curValue.deviceGroupIdList = result.device?.deviceGroupList?.map(
                (val: DeviceGroup) => val.id
            )

            if (result.device?.devicePortList?.length > 0) {
                curValue.devicePortList = result.device.devicePortList.map(
                    (port: any) => {
                        // aby bylo možné editovat načtené
                        return { ...toRaw(port) }
                    }
                )
            } else {
                curValue.devicePortList = []
            }

            if (result.device?.devicePhotoList?.length > 0) {
                result.device.devicePhotoList.forEach((photo: any) => {
                    devicePhotoList.value.push({ ...toRaw(photo) })
                })
            }

            curValue.staticIpId = result.device?.staticIp?.id
            curValue.ownerId = result.device?.owner?.id

            // Nereaktivní
            originalValue = { ...curValue }
        })
    }
}

const { mutate: createDevice } = useMutation(gql`
    mutation createDevice($data: createDevice!) {
        createDevice(device: $data) {
            name
        }
    }
`)

const { mutate: updateDevice } = useMutation(gql`
    mutation updateDevice($id: ID!, $data: updateDevice!) {
        updateDevice(id: $id, device: $data) {
            name
        }
    }
`)

// Device

const { mutate: addDeviceToGroup } = useMutation(gql`
    mutation addDeviceToGroup2($deviceId: ID!, $groupId: ID!) {
        addDeviceToGroup(deviceId: $deviceId, groupId: $groupId)
    }
`)

const { mutate: removeDeviceFromGroup } = useMutation(gql`
    mutation removeDeviceFromGroup2($deviceId: ID!, $groupId: ID!) {
        removeDeviceFromGroup(deviceId: $deviceId, groupId: $groupId)
    }
`)

const { mutate: createDevicePort } = useMutation(gql`
    mutation createDevicePort($devicePort: createDevicePort!) {
        createDevicePort(devicePort: $devicePort) {
            id
        }
    }
`)

const { mutate: removeDevicePort } = useMutation(gql`
    mutation removeDevicePort($id: ID!) {
        removeDevicePort(id: $id)
    }
`)

const { mutate: createDevicePhoto } = useMutation(gql`
    mutation createDevicePhoto($devicePhoto: createDevicePhoto!) {
        createDevicePhoto(devicePhoto: $devicePhoto) {
            id
            filename
        }
    }
`)

const { mutate: removeDevicePhoto } = useMutation(gql`
    mutation removeDevicePhoto($id: ID!) {
        removeDevicePhoto(id: $id)
    }
`)

const removePhotoWrap = (id: string) => {
    removeDevicePhoto({ id: id }).then(() => {
        devicePhotoList.value = devicePhotoList.value.filter(
            (val) => val.id !== id
        )
    })
}

const send = async () => {
    const isFormCorrect = await v$.value.$validate()

    if (!isFormCorrect) {
        return
    }

    const rawData = { ...toRaw(curValue) }

    // Uživatelé mohou přidávat zařízení jen sobě
    if (!userStore.data.isAdmin) {
        rawData.ownerId = userStore.data.id
    }

    // Pokud je ID v adrese, tak update, jinak create
    if (route.params.id !== undefined && route.params.id !== '') {
        // Pokud se staticka ip nemeni, neodesilat
        if (rawData.staticIpId == originalValue?.staticIpId) {
            delete rawData.staticIpId
        }

        // Uložit pouze rozdíly ve skupinách
        const newGroupIdList = rawData.deviceGroupIdList
        const originalDeviceIdList = originalValue?.deviceGroupIdList ?? []

        delete rawData.deviceGroupIdList

        // Uložit pouze rozdíly v portech
        const newDevicePortList = rawData.devicePortList

        delete rawData.devicePortList

        const newDevicePortIdList = newDevicePortList
            .filter((v: any) => !v?.added)
            .map((v: any) => v.id)

        const originalDevicePortIdList =
            originalValue?.devicePortList?.map((v: any) => v.id) ?? []

        // Fotky lze pouze přidat
        delete rawData.devicePhotoList

        updateDevice({
            id: route.params.id,
            data: rawData,
        }).then((values) => {
            const deviceId = route.params.id
            const requestList: MutateResult<void>[] = []

            // Uložit pouze rozdíly ve skupinách
            // To ADD
            newGroupIdList
                .filter((x: any) => !originalDeviceIdList.includes(x))
                .forEach((groupId: string) =>
                    requestList.push(addDeviceToGroup({ deviceId, groupId }))
                )

            // To DEL
            originalDeviceIdList
                .filter((x: any) => !newGroupIdList.includes(x))
                .forEach((groupId: string) =>
                    requestList.push(
                        removeDeviceFromGroup({ deviceId, groupId })
                    )
                )

            // Uložit pouze rozdíly v portech
            // To ADD
            newDevicePortList
                .filter((v: any) => v?.added)
                .forEach((devicePort: CreateDevicePort) => {
                    const data = {
                        devicePort: {
                            deviceId: deviceId,
                            devicePort: devicePort.devicePort,
                            hubPort: devicePort.hubPort,
                            expiration: devicePort.expiration,
                        },
                    }
                    requestList.push(createDevicePort(data))
                })
            // To DEL
            originalDevicePortIdList
                .filter((x) => !newDevicePortIdList.includes(x))
                .forEach((devicePortId: string) =>
                    requestList.push(removeDevicePort({ id: devicePortId }))
                )

            // Počkat na dokončení všech requestů
            Promise.all(requestList).then(() => {
                refetchDevice()
                //router.push({ name: Route.deviceList })
                toast(
                    'Zařízení ' + values?.data.updateDevice.name + ' upraveno',
                    'success'
                )
            })
        })
    } else {
        // Nesmí být id
        rawData.devicePortList = rawData.devicePortList.map(
            (v: CreateDevicePortFromDevice) => {
                return {
                    hubPort: v.hubPort,
                    devicePort: v.devicePort,
                    expiration: v.expiration,
                }
            }
        )

        createDevice({ data: rawData }).then((values) => {
            router.push({ name: Route.deviceList })
            toast(
                'Zařízení ' + values?.data.createDevice.name + ' vytvořeno',
                'success'
            )
        })
    }
}
</script>
<style>
.center {
    margin-top: 1em;
    text-align: center;
}
</style>
